set BFOSDDIR=%DeployRoot%\$OEM$\BigFixOSD
set BFOSDDRIVE=%BFOSDDIR:~0,2%
reg load HKEY_LOCAL_MACHINE\TempHive %BFOSDDRIVE%\Windows\system32\config\SOFTWARE

REM Find the BES Client directory
FOR /F "tokens=2*" %%a IN ('reg query "HKEY_LOCAL_MACHINE\TempHive\Microsoft\Windows\CurrentVersion\App Paths\BESClient.exe" /v Path') DO SET BFDIR=%%~pb%
FOR /F "tokens=2*" %%a IN ('reg query "HKEY_LOCAL_MACHINE\TempHive\Wow6432Node\Microsoft\Windows\CurrentVersion\App Paths\BESClient.exe" /v Path') DO SET BFDIR=%%~pb%

REM Make sure the BES Client is installed on offline image
if "%BFDIR%"=="" goto cleanup

:installed

reg query "HKLM\Hardware\Description\System\CentralProcessor\0" /v Identifier | find "x86"
If %ERRORLEVEL% == 0 (
    REM x86 case
    SET PARENTKEY=HKEY_LOCAL_MACHINE\TempHive\BigFix\EnterpriseClient
) ELSE (
    REM x64 case
    SET PARENTKEY=HKEY_LOCAL_MACHINE\TempHive\Wow6432Node\BigFix\EnterpriseClient
)

REM collect registry keys to migrate
reg query "%PARENTKEY%" /v EnterpriseClientFolder
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%" /v EnterpriseClientFolder') DO SET ClientFolder=%%~db%%~pb%%~nb
reg query "%PARENTKEY%\GlobalOptions" /v StoragePath
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%\GlobalOptions" /v StoragePath') DO SET StoragePath=%%~db%%~pb%%~nb
reg query "%PARENTKEY%\GlobalOptions" /v LibPath
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%\GlobalOptions" /v LibPath') DO SET LibPath=%%~db%%~pb%%~nb
reg query "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value') DO SET BufferDirectory=%%~db%%~pb%%~nb

reg import "%BFOSDDIR%\RegistryKeys\removeSettings.reg"
reg import "%BFOSDDIR%\RegistryKeys\storedSettings.reg"

REM restore registry keys
SET lastChar=%ClientFolder:~-1%
if %lastChar%==\ SET ClientFolderNew=%ClientFolder:~0,-1%
if %lastChar%==\ SET ClientFolder=%ClientFolder%\

SET lastChar=%StoragePath:~-1%
if %lastChar%==\ SET StoragePath=%StoragePath%\

SET lastChar=%LibPath:~-1%
if %lastChar%==\ SET LibPath=%LibPath%\

SET lastChar=%BufferDirectory:~-1%
if %lastChar%==\ SET BufferDirectory=%BufferDirectory%\

if not "%ClientFolder%"=="" (reg add "%PARENTKEY%" /v EnterpriseClientFolder /f /d "%ClientFolder%")
if not "%StoragePath%"=="" (reg add "%PARENTKEY%\GlobalOptions" /v StoragePath /f /d "%StoragePath%")
if not "%LibPath%"=="" (reg add "%PARENTKEY%\GlobalOptions" /v LibPath /f /d "%LibPath%")

if not "%BufferDirectory%"=="" (
reg add "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value /f /d "%BufferDirectory%"
) ELSE ( 
reg add "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value /f /d "%ClientFolderNew%\__BESData\__Global\Upload"
)
:cleanup
reg import "%BFOSDDIR%\RegistryKeys\tag_image.reg"
reg unload HKEY_LOCAL_MACHINE\TempHive