' // BFUtility.vbs - Added utility functions


Function DeleteAll( sFolder )
	Dim oFolder
	Dim oFile
	Dim sStateStore
	
	oLogging.CreateEntry "Enter DeleteAll: Delete all contents of " & sFolder, LogTypeInfo
	
	sStateStore = ""
	If Len(oEnvironment.Item("OSDStateStorePath")) > 3 then
		If Mid(oEnvironment.Item("OSDStateStorePath"), 2, 1) = ":" then
			sStateStore = Mid(oEnvironment.Item("OSDStateStorePath"), 3)
		End if
	End if		
	
	For each oFolder in oFSO.GetFolder(sFolder & "\").Subfolders
			If sStateStore <> "" and Instr(3, oEnvironment.Item("OSDStateStorePath") & "\", Mid(oFolder.Path, 3) & "\", 1) <> 0 then
				oLogging.CreateEntry "Skipping " & oFolder.Path & " because it contains user state.", LogTypeInfo
			
			Else

				Select Case lcase(oFolder.Name)
				Case "minint", "recycler", "system volume information", "deploy", "drivers", "_smstasksequence", "smstslog", "sysprep"
					oLogging.CreateEntry "Skipping " & oFolder.Path, LogTypeInfo
				
				Case Else
					oShell.Run "cmd.exe /c rd /s /q """ & oFolder.Path & """", 0, true
					
					on error resume next
					if oFSO.FolderExists(oFolder.Path) then
					
						ResetFolderPermissions oFolder.Path
						
						oShell.Run "cmd.exe /c rd /s /q """ & oFolder.Path & """", 0, true

					End if
					on error goto 0

				End Select
			End if
		Next
	
End Function

Function ResetFolderPermissions( sPath )
	Dim oFile
	Dim oSD
	Dim stopFile
	
	oLogging.CreateEntry "Enter ResetFolderPermissions: Change security permissions for " & sPath, LogTypeInfo
	
	' // takeown to re-take ownership of folder
	oUtility.RunWithConsoleLogging("takeown.exe /F """ & sPath & """ /R /A /D Y")

	' // Use Win32_SecurityDescriptor and ChangeSecurityPermissionsEx to retrieve and change security permissions recursively
	Set oFile = objWMI.Get("CIM_Directory.Name=" & "'" & sPath & "'") 
	Set oSD = objWMI.Get("Win32_SecurityDescriptor").SpawnInstance_
	oFile.ChangeSecurityPermissionsEx oSD, 4, stopFile, true
	
	oLogging.CreateEntry "Exit ResetFolderPermissions", LogTypeInfo
		
End function

Function SetBareMetalFinalStatus(sStatus)

	Dim iRetVal
	Dim sRbagentDir
	Dim sRbagentPath
	Dim sRbagentCLI
	Dim rbagentExe, platform, logPath, taskid, bomid
		
	oLogging.CreateEntry "About to run SetBareMetalFinalStatus", LogTypeInfo

    oLogging.CreateEntry "About to run rbagent", LogTypeInfo


    platform = oEnvironment.Item("PROCESSOR_ARCHITECTURE")
    If UCase(oUtility.GetPA()) = "X64" then
        rbagentExe = "rbagent64.exe"
    Else
        rbagentExe = "rbagent.exe"
    End if

    sRbagentDir  = oEnvironment.Item("DeployRoot") & "\$OEM$\BigFixOSD\RBAgent"
    sRbagentPath = sRbagentDir & "\" & rbagentExe & " -d -v 4 -n 1:1 rad-temtaskset "

    sRbagentCLI  = "%comspec% /c " & sRbagentPath
    '// Now add the task ID to the rbagent command line, reading it from the deploy folder
    '// where the bare metal should have saved it
    taskid = oFSO.OpenTextFile(sRbagentDir & "\task.id").ReadAll
    bomid = oFSO.OpenTextFile(sRbagentDir & "\bom.id").ReadAll
    sRbagentCLI = sRbagentCLI & "task=" & taskid  & " bom=" & bomid & " status=" & sStatus  

    logPath = oEnvironment.Item("LogPath")
    sRbagentCLI = sRbagentCLI & " > " & logPath & "\SetBareMetalFinalStatus.log 2>&1"

    oLogging.CreateEntry "About to run " & sRbagentCLI, LogTypeInfo
    iRetVal = oShell.run(sRbagentCLI, 0, true)
    If (iRetVal = 0) Then
    	oLogging.CreateEntry "Run of rbagent to set Bare Metal task status completed", LogTypeInfo
    Else
    	oLogging.CreateEntry "Run of rbagent to set Bare Metal task status failed (rc = " & iRetVal & ")", LogTypeInfo
    End If
	
	oLogging.CreateEntry "Completed run of SetBareMetalFinalStatus", LogTypeInfo

End function

Function CopyLogsToBareMetalServer

Dim iRetVal
Dim sRbagentDir
Dim sRbagentPath
Dim sRbagentCLI
Dim sWindowsLogicalDriveLetter

Dim logPath, platform, rbagentExe, taskid, bomid, Return

oLogging.CreateEntry "About to run CopyLogsToBareMetalServer", LogTypeInfo

    oLogging.CreateEntry "About to run rbagent", LogTypeInfo


    platform = oEnvironment.Item("PROCESSOR_ARCHITECTURE")
    If UCase(oUtility.GetPA()) = "X64" then
        rbagentExe = "rbagent64.exe"
    Else
        rbagentExe = "rbagent.exe"
    End if
    
    sWindowsLogicalDriveLetter = Left(oEnvironment.Item("DeployRoot"),1)
    sRbagentDir  = oEnvironment.Item("DeployRoot") & "\$OEM$\BigFixOSD\RBAgent"
    sRbagentPath = sRbagentDir & "\" & rbagentExe & " -d -v 4 -n 1:1 rad-temcopylogs "
    
    sRbagentCLI  = "%comspec% /c " & sRbagentPath
    '// Now add the task ID  and Win Drive Letter to the rbagent command line, reading it from the deploy folder
    '// where the bare metal should have saved it
    taskid = oFSO.OpenTextFile(sRbagentDir & "\task.id").ReadAll
    
	logPath = oEnvironment.Item("LogPath")
    sRbagentCLI = sRbagentCLI & " windrive=" & sWindowsLogicalDriveLetter & " task=" & taskid  & " > " & logPath & "\BFCopyLogs.log 2>&1"

    
    oLogging.CreateEntry "About to run " & sRbagentCLI, LogTypeInfo
    iRetVal = oShell.run(sRbagentCLI, 0, true)
    If (iRetVal = 0) Then
    	oLogging.CreateEntry "Run of rbagent to copy logs completed", LogTypeInfo
    Else
    	oLogging.CreateEntry "Run of rbagent to copy logs failed (rc = " & iRetVal & ")", LogTypeInfo
    End If
    
    oLogging.CreateEntry "Completed run of CopyLogsToBareMetalServer", LogTypeInfo

End Function